import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrBookarticle {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  BookId!: bigint;
  Name?: string;
  Type!: number;
  WordCount!: number;
  Conclusion?: any;
  Guide?: string;
  Tutelage?: string;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrBookarticleSchema = defineEntity({
  class: IcrBookarticle,
  comment: '书籍文章',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    BookId: p.bigint().name('BookId').comment('书Id'),
    Name: p.string().name('Name').nullable().comment('文章名称'),
    Type: p.integer().name('Type').comment('文章类型'),
    WordCount: p.integer().name('WordCount').comment('字数'),
    Conclusion: p.json().name('Conclusion').nullable().comment('结论Json'),
    Guide: p.string().name('Guide').nullable().comment('导读'),
    Tutelage: p.string().name('Tutelage').nullable().comment('指导'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
